Index: imaps-frontend/src/pages/AdminPage/AdminPage.jsx
===================================================================
--- imaps-frontend/src/pages/AdminPage/AdminPage.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/pages/AdminPage/AdminPage.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,228 @@
+import React, {useEffect, useState} from "react";
+import styles from "./AdminPage.module.css";
+import {TilesContainer} from "react-tiles-dnd";
+import HttpService from "../../scripts/net/HttpService.js";
+import config from "../../scripts/net/netconfig.js";
+import card from "../../assets/card-map.png";
+import MapInfoModal from "../../components/MapInfoModal/MapInfoModal.jsx";
+import {useAppContext} from "../../components/AppContext/AppContext.jsx";
+import PublishForm from "../../components/PublishForm/PublishForm.jsx";
+import Logo from "../../components/Logo/Logo.jsx";
+import Profile from "../../components/Profile/Profile.jsx";
+import Toast from "../../components/Toast/Toast.jsx";
+
+const renderTile = ({data, isDragging}, handleApprove, handleDeny, openMapInfoModal, openPublishForm) => (
+    <div className={`${styles.tile} ${isDragging ? styles.dragging : ""}`} onClick={() => openMapInfoModal(data)}>
+        <img src={card} className={styles.imgStyle} alt="Map Thumbnail"/>
+        <div className={styles.mapTitle}>{data.mapName}</div>
+        <button className={styles.viewPublishFormButton} onClick={(e) => {
+            e.stopPropagation();
+            openPublishForm(data);
+        }}>
+            View Form
+        </button>
+        <div className={styles.buttonContainer}>
+            {/*<input*/}
+            {/*    type="text"*/}
+            {/*    placeholder="Reason"*/}
+            {/*    className={styles.reasonInput}*/}
+            {/*    onClick={(e) => e.stopPropagation()}*/}
+            {/*/>*/}
+            {/*<div className={styles.buttonsGroup}>*/}
+            {/*    <button className={styles.approveButton} onClick={(e) => {*/}
+            {/*        e.stopPropagation();*/}
+            {/*        handleApprove(data.mapName);*/}
+            {/*    }}>*/}
+            {/*        Approve*/}
+            {/*    </button>*/}
+            {/*    <button className={styles.denyButton} onClick={(e) => {*/}
+            {/*        e.stopPropagation();*/}
+            {/*        const reason = e.target.closest('div').previousSibling.value;*/}
+            {/*        handleDeny(data.mapName, reason);*/}
+            {/*    }}>*/}
+            {/*        Deny*/}
+            {/*    </button>*/}
+
+            {/*</div>*/}
+        </div>
+    </div>
+);
+
+const tileSize = (tile) => ({
+    colSpan: tile.cols,
+    rowSpan: tile.rows,
+});
+
+export default function AdminPage() {
+    const [pendingMaps, setPendingMaps] = useState([]);
+    const [selectedMap, setSelectedMap] = useState(null);
+    const [isMapInfoModalOpen, setIsMapInfoModalOpen] = useState(false);
+    const [publishFormMap, setPublishFormMap] = useState(null);
+    const [publishRequests, setPublishRequests] = useState([]);
+    const [currentForm, setCurrentForm] = useState({});
+    const {username} = useAppContext();
+
+    const [toastMessage, setToastMessage] = useState(null);
+    const [toastType, setToastType] = useState(1);
+
+    useEffect(() => {
+        const loadPendingMaps = async () => {
+            const httpService = new HttpService();
+            httpService.setAuthenticated();
+
+            const respMaps = await httpService.get(`${config.admin.display}`);
+
+            const mapTiles = respMaps.map((elem) => ({
+                mapName: elem.mapName,
+                cols: 1,
+                rows: 1,
+                status: elem.mapStatus,
+                created_at: elem.createdAt,
+                modified_at: elem.modifiedAt,
+                gmaps_url: elem.gmaps_url,
+                image_url: card,
+            })).filter((tile) => tile.status === "INVALID");
+
+            setPendingMaps(mapTiles);
+        };
+
+        loadPendingMaps();
+    }, [username]);
+
+    useEffect(() => {
+        const loadPublishRequests = async () => {
+            const httpService = new HttpService(true);
+            const respPr = await httpService.get(`${config.admin.load_pr}`)
+
+            setPublishRequests(respPr);
+        }
+
+        loadPublishRequests();
+    }, []);
+
+    const handleApprove = async (id,mapName) => {
+        const httpService = new HttpService();
+        httpService.setAuthenticated();
+        const url = `${config.admin.approve_pr}?id=${id}`;
+        closePublishForm()
+        try {
+            await httpService.post(url);
+            setPendingMaps((prev) => prev.filter((map) => map.mapName !== mapName));
+            showToast(`Publish Request "${id}" approved.`, 1)
+        } catch (error) {
+            console.error("Error approving pr:", error);
+            // alert("Failed to approve pr.");
+            showToast("Failed to approve pr.", 0)
+        }
+    };
+
+    const showToast = (message, type = 1) => {
+        setToastMessage(message);
+        setToastType(type);
+        setTimeout(() => setToastMessage(null), 3000); // Automatically hide the toast after 3 seconds
+    };
+
+    const handleDeny = async (id, mapName,reason) => {
+        const httpService = new HttpService();
+        httpService.setAuthenticated();
+        const url = `${config.admin.deny_pr}?id=${id}&reason=${encodeURIComponent(reason)}`;
+        closePublishForm()
+        try {
+            await httpService.post(url);
+            setPendingMaps((prev) => prev.filter((map) => map.mapName !== mapName));
+            showToast(`Publish request ${id} denied.`, 1)
+        } catch (error) {
+            console.error("Error denying pr:", error);
+            alert("Failed to deny pr.");
+            showToast("Failed to deny pr.", 0)
+        }
+    };
+
+    const handlePublishFormSubmit = async (formData) => {
+        const httpService = new HttpService();
+        httpService.setAuthenticated();
+        const url = `${config.admin.approve_pr}?mapName=${formData.mapName}`;
+
+        try {
+            await httpService.post(url, formData); // Assuming formData contains all required fields
+            setPendingMaps((prev) => prev.filter((map) => map.mapName !== formData.mapName));
+            alert(`Map "${formData.mapName}" published successfully.`);
+            closePublishForm();
+        } catch (error) {
+            console.error("Error publishing map:", error);
+            alert("Failed to publish map. Please try again.");
+        }
+    };
+
+
+    const openMapInfoModal = (map) => {
+        setSelectedMap(map);
+        setIsMapInfoModalOpen(true);
+    };
+
+    const closeMapInfoModal = () => {
+        setIsMapInfoModalOpen(false);
+        setSelectedMap(null);
+    };
+
+    const openPublishForm = (data) => {
+        console.log("DATA MAP NAME", data.mapName)
+        publishRequests.forEach(pr => {
+            console.log("PR: " + JSON.stringify(pr))
+        })
+
+        const pr = publishRequests.find(p => p.mapName === data.mapName);
+        console.log("FOUND PR: " + pr)
+        setCurrentForm(pr)
+        setPublishFormMap(data);
+    };
+
+    const closePublishForm = () => {
+        setPublishFormMap(null);
+    };
+
+    return (
+        <div className={styles.container}>
+            <Logo></Logo>
+            <Profile></Profile>
+            <h1>Pending Maps for Approval</h1>
+
+            {publishFormMap && (
+                <PublishForm
+                    isAdmin={true}
+                    formData={currentForm}
+                    onSubmit={handlePublishFormSubmit}
+                    onCancel={closePublishForm}
+                    onApprove={handleApprove}
+                    onDeny={handleDeny}
+
+                />
+            )}
+
+
+            <div className={styles.mapsContainer}>
+                <TilesContainer
+                    data={pendingMaps}
+                    renderTile={(tileProps) => renderTile(tileProps, handleApprove, handleDeny, openMapInfoModal, openPublishForm)}
+                    tileSize={tileSize}
+                    forceTileWidth={200}
+                    forceTileHeight={250}
+                />
+            </div>
+            {isMapInfoModalOpen && (
+                <MapInfoModal
+                    isOpen={isMapInfoModalOpen}
+                    onClose={closeMapInfoModal}
+                    map={selectedMap}
+                    onUpdate={() => {
+                    }}
+                    onDelete={() => {
+                    }}
+                    published={true}
+                />
+            )}
+            {toastMessage && <Toast message={toastMessage} type={toastType} onClose={() => setToastMessage(null)}/>}
+
+        </div>
+    );
+}
Index: imaps-frontend/src/pages/BrowseMaps/BrowseMaps.jsx
===================================================================
--- imaps-frontend/src/pages/BrowseMaps/BrowseMaps.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/pages/BrowseMaps/BrowseMaps.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,165 @@
+import styles from "./Maps.module.css";
+import "react-tiles-dnd/esm/index.css";
+import { TilesContainer } from "react-tiles-dnd";
+import { Link } from "react-router-dom";
+import card from "../../assets/card-map.png";
+import star_icon from "../../assets/star_icon.png"; // Unfilled star icon
+import star_filled_icon from "../../assets/star_filled_icon.png"; // Filled star icon
+import { useEffect, useState } from "react";
+import HttpService from "../../scripts/net/HttpService.js";
+import Logo from "../../components/Logo/Logo.jsx";
+import Profile from "../../components/Profile/Profile.jsx";
+import config from "../../scripts/net/netconfig.js";
+import { useAppContext } from "../../components/AppContext/AppContext.jsx";
+
+let loadedTiles = [];
+
+const renderTile = ({ data, isDragging, toggleFavorite }) => (
+    <div style={{ padding: "1rem", width: "100%", position: "relative" }}>
+        <Link to={`/Maps/${data.text}/View`} className={styles.linkStyle}>
+            <div
+                className={`${styles.tile} ${isDragging ? styles.dragging : ""}`}
+                style={{ width: "100%", height: "100%" }}
+            >
+                <img src={card} className={styles.imgStyle} alt="Map Thumbnail" />
+                <div style={{ fontFamily: "exo" }}>
+                    {data.text} {isDragging ? "DRAGGING" : null}
+                </div>
+            </div>
+        </Link>
+        <div className={styles.favorite} onClick={() => toggleFavorite(data.text, data.isFavorite)}>
+            <img
+                src={data.isFavorite ? star_filled_icon : star_icon}
+                alt="Favorite Icon"
+                style={{ width: "20px", height: "20px" }}
+            />
+        </div>
+    </div>
+);
+
+const tileSize = (tile) => ({
+    colSpan: tile.cols,
+    rowSpan: tile.rows,
+});
+
+export default function BrowseMaps() {
+    const [searchTerm, setSearchTerm] = useState("");
+    const [tiles, setTiles] = useState([]);
+    const { username, isAuthenticated } = useAppContext();
+
+    useEffect(() => {
+        const loadMaps = async () => {
+            const httpService = new HttpService();
+            let mapTiles = [];
+
+            if (isAuthenticated) {
+                // :D
+                const favResp = await httpService.get(`${config.favourites.display}?username=${username}`);
+                console.log("RESPONSE FAVORITE MAPS", favResp);
+
+                const favMapTiles = favResp.map((elem) => ({
+                    text: elem.mapName,
+                    cols: 1,
+                    rows: 1,
+                    isFavorite: true,
+                }));
+
+                // Load all maps
+                const allResp = await httpService.get(config.view_maps.display);
+                console.log("RESPONSE MAPS PUBLIC", allResp);
+
+                const nonFavMapTiles = allResp
+                    .filter((elem) => !favMapTiles.some((fav) => fav.text === elem.mapName))
+                    .map((elem) => ({
+                        text: elem.mapName,
+                        cols: 1,
+                        rows: 1,
+                        isFavorite: false,
+                    }));
+
+                mapTiles = [...favMapTiles, ...nonFavMapTiles];
+            } else {
+                const allResp = await httpService.get(config.view_maps.display);
+                console.log("RESPONSE MAPS PUBLIC", allResp);
+
+                mapTiles = allResp.map((elem) => ({
+                    text: elem.mapName,
+                    cols: 1,
+                    rows: 1,
+                    isFavorite: false,
+                }));
+            }
+
+            loadedTiles = [...mapTiles];
+            sortTiles(mapTiles);
+            setTiles(mapTiles);
+        };
+        loadMaps();
+    }, [isAuthenticated, username]);
+
+    const toggleFavorite = async (tileName, isFavorite) => {
+        const httpService = new HttpService();
+        const url = isFavorite
+            ? `${config.favourites.delete}?username=${username}&mapName=${encodeURIComponent(tileName)}`
+            : `${config.favourites.add}?username=${username}&mapName=${encodeURIComponent(tileName)}`;
+
+        console.log("Request URL:", url);
+        let response;
+        if (isFavorite) {
+            response = await httpService.delete(url);
+        } else {
+            response = await httpService.post(url);
+        }
+        console.log("Response received:", response);
+
+        const updatedTiles = tiles.map((tile) =>
+            tile.text === tileName ? { ...tile, isFavorite: !tile.isFavorite } : tile
+        );
+
+        loadedTiles = [...updatedTiles];
+        sortTiles(updatedTiles);
+        setTiles(updatedTiles);
+    };
+
+    const handleSearchChange = (e) => {
+        const value = e.target.value.toLowerCase();
+        setSearchTerm(value);
+
+        const filteredTiles = loadedTiles.filter((tile) =>
+            tile.text.toLowerCase().includes(value)
+        );
+        sortTiles(filteredTiles);
+        setTiles(filteredTiles);
+    };
+
+    const sortTiles = (tilesToSort) => {
+        tilesToSort.sort((a, b) => {
+            if (a.isFavorite === b.isFavorite) return a.text.localeCompare(b.text);
+            return a.isFavorite ? -1 : 1;
+        });
+    };
+
+    return (
+        <div className={styles.container}>
+            <h1>Explore Maps</h1>
+            <Logo></Logo>
+            <Profile></Profile>
+            <div className={styles.searchBar}>
+                <input
+                    type="text"
+                    placeholder="Search for maps..."
+                    value={searchTerm}
+                    onChange={handleSearchChange}
+                />
+            </div>
+
+            <TilesContainer
+                data={tiles}
+                renderTile={(props) => renderTile({ ...props, toggleFavorite })}
+                tileSize={tileSize}
+                forceTileWidth={150}
+                forceTileHeight={170}
+            />
+        </div>
+    );
+}
Index: imaps-frontend/src/pages/Draw/Draw.jsx
===================================================================
--- imaps-frontend/src/pages/Draw/Draw.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/pages/Draw/Draw.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,116 +1,153 @@
-import { useEffect, useState } from "react";
-import { MapBuilder } from "../../scripts/main/MapBuilder.js";
+import { useContext, useEffect, useState } from "react";
 import styles from "./Draw.module.css";
-import RoomModal from "../../components/RoomModal/RoomModal.jsx";
-import SideBar from "../../components/SideBar/SideBar.jsx";
-import EntranceModal from "../../components/EntranceModal/EntranceModal.jsx";
+import RoomModal from "../../components/Modals/RoomModal/RoomModal.jsx";
+import EntranceModal from "../../components/Modals/EntranceModal/EntranceModal.jsx";
 import DrawGuide from "../../components/DrawGuide/DrawGuide.jsx";
-import RoomTypeModal from "../../components/RoomTypeModal/RoomTypeModal.jsx";
-import InfoPinModal from "../../components/InfoPinModal/InfoPinModal.jsx";
+import RoomTypeModal from "../../components/Modals/RoomTypeModal/RoomTypeModal.jsx";
+import InfoPinModal from "../../components/Modals/InfoPinModal/InfoPinModal.jsx";
+import SaveMap from "../../components/SaveMap/SaveMap.jsx";
+import Logo from "../../components/Logo/Logo.jsx";
+import { Link, useNavigate, useParams, useSearchParams } from "react-router-dom";
+import Profile from "../../components/Profile/Profile.jsx";
 import HttpService from "../../scripts/net/HttpService.js";
-import SaveMap from "../../components/SaveMap/SaveMap.jsx";
-import logo from "../../assets/logo_icon.png";
-import MapTemplateSelector from "../../components/MapTemplateSelector/LoadMap.jsx";
-import KeymapPanel from "../../components/KeyMappingsGuidePanel/KeymapPanel.jsx";
-import { Link } from "react-router-dom";
+import StairsModal from "../../components/Modals/StairsModal/StairsModal.jsx";
+import useMapLoader from "./Hooks/useMapLoader.js";
+import {FloorSelector} from "./FloorSelector.jsx";
+import {useRoomTypesLoader} from "./Hooks/useRoomTypesLoader.js";
+import {useAppContext} from "../../components/AppContext/AppContext.jsx";
+import config from "../../scripts/net/netconfig.js";
+import ShapeRegistry from "../../scripts/util/ShapeRegistry.js";
 
 function Draw() {
-  const [selectedFloor, setSelectedFloor] = useState(1);
-  const [app, setApp] = useState(null);
+  const { mapName } = useParams();
+  const { username } = useAppContext();
+
   const [isPopupVisible, setIsPopupVisible] = useState(false);
+  const [errorMessage, setErrorMessage] = useState("Error");
+  const [hasError, setHasError] = useState(false);
+  const [searchParams, setSearchParams] = useSearchParams();
+
+  const[roomTypes,setRoomTypes] = useState([]);
+
+  const {app,floors,saveFloor,setFloors} = useMapLoader(mapName,username,searchParams,setSearchParams)
+  const {addRoomType} = useRoomTypesLoader(setRoomTypes,mapName,username);
+
+  const addFloorHandler = async (newFloorNum) => {
+    const httpService = new HttpService();
+    httpService.setAuthenticated();
+
+    const payload = {
+      num: newFloorNum,
+      mapName: mapName,
+    };
+
+    try {
+      await httpService.put(`${config.floors.add}`, payload);
+      console.log(`Added floor ${newFloorNum}`);
+      setFloors((prevFloors) => [...prevFloors, { num: newFloorNum }]);
+    } catch (error) {
+      console.error("Error adding floor:", error);
+    }
+  };
+
+  const deleteFloorHandler = async (floorNum) => {
+    if(floorNum === 0) return
+
+    const httpService = new HttpService();
+    httpService.setAuthenticated();
+
+    try {
+      await httpService.delete(`${config.floors.delete}?floorNum=${floorNum}&mapName=${mapName}`);
+      setFloors((prevFloors) => prevFloors.filter(f => f.num !== floorNum))
+
+      const currFloor = searchParams.get("floor");
+      if(currFloor == floorNum){
+        setSearchParams({floor:"0"},{replace:true})
+      }
+      console.log(`Deleted floor ${floorNum}`);
+    } catch (error) {
+      console.error("Error deleting floor:", error);
+    }
+  };
+
   useEffect(() => {
-    const app = new MapBuilder("container");
-    setApp(app);
-    // fpsCounterLoop();
+    return () => {
+      ShapeRegistry.clear();
+    }
   }, []);
 
-  const handleFloorChange = (event) => {
-    setSelectedFloor(event.target.value);
-    console.log(`Floor changed to: ${event.target.value}`);
-  };
 
-  const handleRenderClick = () => {
-    setIsPopupVisible(true);
+  const handleSaveClick = async () => {
+    saveFloor().then(r => {
+     floors.forEach(flr => {
+       setIsPopupVisible(true);
+       setTimeout(() => {
+         setIsPopupVisible(false);},
+           3000);
+       console.log("floor after save: " + JSON.stringify(flr))
+     })
+    });
 
-    setTimeout(() => {
-      setIsPopupVisible(false);
-    }, 3000);
-  };
 
-  const handleSaveClick = async (mapName) => {
-    const resp = await app.saveMap(mapName);
-  };
-  const handleLoadMapClick = (data) => {
-    app.deserializeMap(data);
   };
 
   return (
     <div className={styles.wrapper} id="wrapper">
-      <SideBar></SideBar>
+      {/* <SideBar></SideBar> */}
+      <Logo></Logo>
       <div id="container" className={styles.cont}></div>
       <div className={styles.panel}>
-        <Link to="/">
-          <img src={logo} alt="Finki Logo" className={styles.logo} />
+        <div className={styles.topPanelH}>
+          <Profile position="inline"></Profile>
+        </div>
+        <Link to={`/myMaps/${mapName}/View`} className={styles.titleLink}>
+          <h1 className={styles.title}>{mapName}</h1>
         </Link>
-        <h1 className={styles.title}>Map Builder</h1>
-        {/* <div id="fpscont" className={styles.fpscounter}>
-          <p id="fpsCounter"></p>
-        </div> */}
         <div className={styles.guideWrapper}>
-          <DrawGuide />
+          <DrawGuide/>
         </div>
-
-        {/* <div className={styles.floorSelector}>
-          <label htmlFor="floorSelect">Select Floor:</label>
-          <select
-            id="floorSelect"
-            value={selectedFloor}
-            onChange={handleFloorChange}
-            className={styles.floorDropdown}
-          >
-            <option value={1}>1st Floor</option>
-            <option value={2}>2nd Floor</option>
-            <option value={3}>3rd Floor</option>
-            <option value={4}>4th Floor</option>
-          </select>
-        </div> */}
-        {/* <h2 className={styles.paragraph}>Objects:</h2> */}
+        <hr/>
+        <br/>
+        {/* {<h2 className={styles.paragraph}>Objects:</h2>} */}
         <ul className={styles.shapeOptions} id="shapeOptions">
           <li data-info="Entrance" className={`${styles.shapeOption} ${styles.entrance}`}></li>
           <li data-info="Wall" className={`${styles.shapeOption} ${styles.wall}`} id="wall"></li>
           <li data-info="Room" className={`${styles.shapeOption} ${styles.room}`} id="room"></li>
+          <li data-info="Stairs" className={`${styles.shapeOption} ${styles.stairs}`} id="stairs"></li>
         </ul>
-        <br />
-        <RoomTypeModal map={app}></RoomTypeModal>
+        <RoomTypeModal map={app} roomTypes={roomTypes} addRoomTypeDB={addRoomType}></RoomTypeModal>
+        <br/>
+        <hr/>
+        <br/>
+        <FloorSelector floorConfig={{
+          floors,searchParams,
+          setSearchParams,addFloorHandler,
+          deleteFloorHandler
+        }}></FloorSelector>
 
-        <div id="render" className={styles.buttonContainer}>
-          <button
-            id="render-button"
-            type="button"
-            className={styles.renderButton}
-            onClick={handleRenderClick}
-          >
-            Render
-          </button>
-        </div>
+        <br/>
+
+        <hr/>
+        <br/>
+        {hasError && <p style={{color: "red", textAlign: "center"}}>{errorMessage}</p>}
         <div className={styles.templateCont}>
           <SaveMap submitHandler={handleSaveClick}></SaveMap>
-          <MapTemplateSelector loadHandler={handleLoadMapClick}></MapTemplateSelector>
         </div>
 
         <div className={styles.hide}>
-          <RoomModal map={app}></RoomModal>
+          <RoomModal map={app} roomTypes={roomTypes}></RoomModal>
           <EntranceModal map={app}></EntranceModal>
           <InfoPinModal map={app}></InfoPinModal>
+          <StairsModal map={app}></StairsModal>
         </div>
       </div>
 
       {isPopupVisible && (
-        <div className={styles.popup}>
-          <div className={styles.popupContent}>
-            <h2>Map Rendered!</h2>
-            <p>Your map has been successfully rendered.</p>
+          <div className={styles.popup}>
+            <div className={styles.popupContent}>
+              <h2>Map Saved!</h2>
+              <p>Your map has been successfully saved.</p>
+            </div>
           </div>
-        </div>
       )}
     </div>
Index: imaps-frontend/src/pages/Draw/FloorSelector.jsx
===================================================================
--- imaps-frontend/src/pages/Draw/FloorSelector.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/pages/Draw/FloorSelector.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,60 @@
+import styles from "./Draw.module.css";
+import plus_icon from "../../assets/plus_icon.png";
+
+export const FloorSelector = ({floorConfig}) => {
+
+    const {floors,searchParams,addFloorHandler,setSearchParams,deleteFloorHandler} = floorConfig;
+
+    return (
+        <div className={styles.floorSection}>
+            <div className={styles.floorList}>
+                <label className={styles.floorLabel}>Available Floors:</label>
+                <div className={styles.floorItems}>
+                    {/* Add new positive floor above */}
+                    <button
+                        className={styles.addFloorButton}
+                        onClick={() => {
+                            const newFloor = Math.max(...floors.map((f) => f.num)) + 1;
+                            addFloorHandler(newFloor);
+                        }}
+                    >
+                        <img src={plus_icon} alt="Add Positive Floor" className={styles.icon}/>
+                    </button>
+
+                    {/* Display editable floors */}
+                    {floors
+                        .sort((a, b) => b.num - a.num)
+                        .map((floor) => (
+                            <div key={floor.num} className={styles.floorItemWrapper}>
+                                <button
+                                    onClick={() => setSearchParams({floor: floor.num}, {replace: true})}
+                                    className={`${styles.floorItem} ${
+                                        searchParams.get("floor") == floor.num ? styles.activeFloor : ""
+                                    }`}
+                                >
+                                    Floor {floor.num}
+                                </button>
+                                <button
+                                    className={styles.deleteFloorButton}
+                                    onClick={() => deleteFloorHandler(floor.num)}
+                                >
+                                    🗑️
+                                </button>
+                            </div>
+                        ))}
+
+                    {/* Add new negative floor below */}
+                    <button
+                        className={styles.addFloorButton}
+                        onClick={() => {
+                            const newFloor = Math.min(...floors.map((f) => f.num)) - 1;
+                            addFloorHandler(newFloor);
+                        }}
+                    >
+                        <img src={plus_icon} alt="Add Negative Floor" className={styles.icon}/>
+                    </button>
+                </div>
+            </div>
+        </div>
+    )
+}
Index: imaps-frontend/src/pages/Draw/Hooks/useMapLoader.js
===================================================================
--- imaps-frontend/src/pages/Draw/Hooks/useMapLoader.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/pages/Draw/Hooks/useMapLoader.js	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,114 @@
+import { useState, useEffect } from "react";
+import HttpService from "../../../scripts/net/HttpService.js";
+import {MapBuilder} from "../../../scripts/main/MapBuilder.js";
+import parseMapData from "../../../scripts/util/parseMapData.js";
+import ShapeRegistry from "../../../scripts/util/ShapeRegistry.js";
+import saveMap from "../../../components/SaveMap/SaveMap.jsx";
+import triggerMapSave from "../../../scripts/util/triggerMapSave.js";
+import config from "../../../scripts/net/netconfig.js";
+
+
+
+const useMapLoader = (mapName, username, searchParams, setSearchParams) => {
+    const [floors, setFloors] = useState([]);
+    const [mapLoaded, setMapLoaded] = useState(false);
+    const [app, setApp] = useState(null);
+
+    useEffect(() => {
+        if (!searchParams.has("floor")) {
+            setSearchParams({ floor: "0"},{replace:true});
+        }
+    }, [setSearchParams, searchParams]);
+
+    useEffect(() => {
+        const loadFloors = async () => {
+            const httpService = new HttpService();
+            try {
+                const respFloors = await httpService.get(`${config.my_maps.load}?mapName=${mapName}&username=${username}`);
+                console.log("Floors loaded:", respFloors);
+                setFloors(respFloors);
+                setMapLoaded(true);
+
+                respFloors.forEach(flr => {
+                    parseMapData(flr.mapData,() => true,false)
+                })
+
+            } catch (e) {
+                console.error("Can't load map:", e.message);
+            }
+        };
+
+        if (!mapLoaded) {
+            loadFloors();
+
+        }
+    }, [mapName, username]);
+
+    // floor change
+    useEffect(() => {
+        if (!mapLoaded || floors === undefined || floors.length === 0) return;
+
+        const floorNum = parseInt(searchParams.get("floor"));
+        const selectedFloor = floors.find((f) => f.num === floorNum);
+
+        if (!selectedFloor) {
+            console.error(`Floor ${floorNum} not found`);
+            return;
+        }
+
+        console.log("Changing to floor:", selectedFloor);
+
+        const appInstance = new MapBuilder("container", floorNum, mapName);
+        appInstance.loadNewFloor(selectedFloor);
+        setApp(appInstance);
+        console.log("Fchange");
+        triggerMapSave();
+
+        }, [searchParams, mapLoaded]);
+
+
+    const saveFloor = async () => {
+        const payload = app.saveShapeDetails();
+        const httpService = new HttpService(true);
+        try {
+            const responseFloor = await httpService.put(`${config.my_maps.save}?username=${username}`, payload);
+            console.log("FLOORS",floors.length)
+
+            setFloors((prevFloors) =>
+                prevFloors.map(floor => floor.num === responseFloor.num ? responseFloor : floor)
+            )
+            console.log(responseFloor, "resp in builder");
+        } catch (err) {
+            console.log("ERROR --> Could not Save map --->", err);
+        }
+    }
+
+
+    useEffect(() => {
+        if (app) {
+            const handleSaveFloor = () => {
+                console.log("mapsave event triggered");
+                saveFloor();
+            };
+
+            window.addEventListener("mapsave", handleSaveFloor);
+            return () => {
+                window.removeEventListener("mapsave", handleSaveFloor);
+            };
+        }
+    }, [app]);
+
+
+    useEffect(() => {
+        return () => {
+            if (app) {
+                app.clearMap();
+                app.stage.destroy();
+            }
+        };
+    }, [app]);
+
+    return { app, floors, saveFloor,setFloors};
+};
+
+export default useMapLoader;
